diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
index 384d6a824..f32271393 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
@@ -665,109 +645,74 @@ public class Chunk
     }
 
     public void onLoad() {
-        isLoaded = true;
-        world.addAllBlockEntities(tileEntityMap.values());
+        this.isLoaded = true;
+        this.world.addAllBlockEntities(this.tileEntityMap.values());
 
-        for (ChunkSection section : sections) {
-            section.onLoad(world);
-        }
-
-        // Perform time correction on delayed ticks
-        if (this.ticksOnUnload >= 0) {
-            final long oldTime = this.ticksOnUnload;
-            final long newTime = this.world.getWorldTime();
-            for (final @NotNull NextTickListEntry entry : this.tickList.values()) {
-                final long ticksRemaining = entry.getEndTime() - oldTime;
-                entry.creationTime = newTime;
-                entry.delay = ticksRemaining;
-            }
-        }
-
-        this.scheduleLoadedUpdates();
-    }
-
-    private void scheduleLoadedUpdates() {
-        final @NotNull Int2ObjectMap<NextTickListEntry> oldTickList = this.tickList;
-        this.tickList = new Int2ObjectArrayMap<>();
-
-        final @NotNull TilePos worldPos = new TilePos(this.pos, new ChunkTilePos(0, 0, 0));
-        for (final @NotNull NextTickListEntry entry : oldTickList.values()) {
-            final @NotNull TilePos entryPos = new TilePos(entry.x, entry.y, entry.z);
-            this.world.scheduleBlockUpdate(worldPos.add(entryPos), entry.blockId, entry.delay, true);
+        for (ChunkSection section : this.sections) {
+            section.onLoad(this.world);
         }
     }
 
     public void onUnload() {
-        isLoaded = false;
+        this.isLoaded = false;
         TileEntity tileentity;
-        for(Iterator<TileEntity> iterator = tileEntityMap.values().iterator(); iterator.hasNext(); tileentity.invalidate())
-        {
+        for (Iterator<TileEntity> iterator = this.tileEntityMap.values().iterator(); iterator.hasNext(); tileentity.invalidate()) {
             tileentity = iterator.next();
         }
 
-        for (ChunkSection section : sections) {
-            section.onUnload(world);
+        for (ChunkSection section : this.sections) {
+            section.onUnload(this.world);
         }
     }
 
-    public void setChunkModified()
-    {
-        isModified = true;
+    public void setChunkModified() {
+        this.isModified = true;
     }
 
-    public void getEntitiesWithin(Entity toExclude, AABB aabb, List<Entity> entities)
-    {
-        int minSection = Math.max(0, MathHelper.floor((aabb.minY - 2D) / 16D));
-        int maxSection = Math.min(MathHelper.floor((aabb.maxY + 2D) / 16D), CHUNK_SECTIONS - 1);
-        for(int section = minSection; section <= maxSection; section++) {
+    public void getEntitiesWithin(@Nullable Entity toExclude, @NotNull AABBdc aabb, @NotNull List<@NotNull Entity> entities) {
+        int minSection = Math.max(0, MathHelper.floor((aabb.minY() - 2D) / 16D));
+        int maxSection = Math.min(MathHelper.floor((aabb.maxY() + 2D) / 16D), CHUNK_SECTIONS - 1);
+        for (int section = minSection; section <= maxSection; section++) {
             getSection(section).getEntitiesWithin(toExclude, aabb, entities);
         }
     }
 
-    public <T extends Entity> void getEntitiesWithin(Class<T> ofClass, AABB aabb, List<@NotNull T> entities)
-    {
-        int minSection = Math.max(0, MathHelper.floor((aabb.minY - 2D) / 16D));
-        int maxSection = Math.min(MathHelper.floor((aabb.maxY + 2D) / 16D), CHUNK_SECTIONS - 1);
-        for(int section = minSection; section <= maxSection; section++) {
+    public <T extends Entity> void getEntitiesWithin(@NotNull Class<T> ofClass, @NotNull AABBdc aabb, @NotNull List<@NotNull T> entities) {
+        int minSection = Math.max(0, MathHelper.floor((aabb.minY() - 2D) / 16D));
+        int maxSection = Math.min(MathHelper.floor((aabb.maxY() + 2D) / 16D), CHUNK_SECTIONS - 1);
+        for (int section = minSection; section <= maxSection; section++) {
             getSection(section).getEntitiesWithin(ofClass, aabb, entities);
         }
     }
 
-    public boolean needsSaving(boolean saveImmediately)
-    {
-        if(neverSave)
-        {
+    public boolean needsSaving(boolean saveImmediately) {
+        if (this.neverSave) {
             return false;
         }
-        if(saveImmediately)
-        {
-            if(hasEntities && world.getWorldTime() != lastSaveTime)
-            {
+        if (saveImmediately) {
+            if (this.hasEntities && this.world.getWorldTime() != this.lastSaveTime) {
                 return true;
             }
-        }
-        else if(hasEntities && world.getWorldTime() >= lastSaveTime + 600L)
-        {
+        } else if (this.hasEntities && this.world.getWorldTime() >= this.lastSaveTime + 600L) {
             return true;
         }
-        return isModified;
+        return this.isModified;
     }
 
-    public int setChunkData(byte[] data, int minX, int minY, int minZ, int maxX, int maxY, int maxZ,
-            int startIndex)
-    {
+    public int setChunkData(byte @NotNull [] data, int minX, int minY, int minZ, int maxX, int maxY, int maxZ,
+                            int startIndex) {
         int minSectionY = minY / ChunkSection.SECTION_SIZE_Y;
         int maxSectionY = (int) Math.ceil((double) maxY / (double) ChunkSection.SECTION_SIZE_Y);
 
         for (int sectionY = minSectionY; sectionY <= maxSectionY; sectionY++) {
-            if (sectionY < 0 || sectionY >= sections.length) continue;
+            if (sectionY < 0 || sectionY >= this.sections.length) continue;
 
             int minYSection = minY - (sectionY * ChunkSection.SECTION_SIZE_Y);
             int maxYSection = maxY - (sectionY * ChunkSection.SECTION_SIZE_Y);
             if (minYSection < 0) minYSection = 0;
             if (maxYSection > ChunkSection.SECTION_SIZE_Y) maxYSection = ChunkSection.SECTION_SIZE_Y;
 
-            startIndex = sections[sectionY].setChunkSectionData(data, minX, minYSection, minZ, maxX, maxYSection, maxZ, startIndex);
+            startIndex = this.sections[sectionY].setChunkSectionData(data, minX, minYSection, minZ, maxX, maxYSection, maxZ, startIndex);
         }
 
         recalcHeightmapOnly();
@@ -775,80 +720,76 @@ public class Chunk
         // Read temperature array
         for (int x = minX; x < maxX; x++) {
             for (int z = minZ; z < maxZ; z++) {
-                temperature[x * CHUNK_SIZE_Z + z] = (double) (data[startIndex++] & 0xff) / 255D;
+                this.temperature[x * CHUNK_SIZE_Z + z] = (double) (data[startIndex++] & 0xff) / 255D;
             }
         }
 
         // Read humidity array
         for (int x = minX; x < maxX; x++) {
             for (int z = minZ; z < maxZ; z++) {
-                humidity[x * CHUNK_SIZE_Z + z] = (double) (data[startIndex++] & 0xff) / 255D;
+                this.humidity[x * CHUNK_SIZE_Z + z] = (double) (data[startIndex++] & 0xff) / 255D;
             }
         }
 
         // Read variety array
         for (int x = minX; x < maxX; x++) {
             for (int z = minZ; z < maxZ; z++) {
-                variety[x * CHUNK_SIZE_Z + z] = (double) (data[startIndex++] & 0xff) / 255D;
+                this.variety[x * CHUNK_SIZE_Z + z] = (double) (data[startIndex++] & 0xff) / 255D;
             }
         }
 
         return startIndex;
     }
-    
-    public int getChunkData(byte[] data, int minX, int minY, int minZ, int maxX, int maxY, int maxZ, int startIndex)
-    {
+
+    public int getChunkData(byte @NotNull [] data, int minX, int minY, int minZ, int maxX, int maxY, int maxZ, int startIndex) {
         int minSectionY = minY / ChunkSection.SECTION_SIZE_Y;
         int maxSectionY = (int) Math.ceil((double) maxY / (double) ChunkSection.SECTION_SIZE_Y);
 
         for (int sectionY = minSectionY; sectionY <= maxSectionY; sectionY++) {
-            if (sectionY < 0 || sectionY >= sections.length) continue;
+            if (sectionY < 0 || sectionY >= this.sections.length) continue;
 
             int minYSection = minY - (sectionY * ChunkSection.SECTION_SIZE_Y);
             int maxYSection = maxY - (sectionY * ChunkSection.SECTION_SIZE_Y);
             if (minYSection < 0) minYSection = 0;
             if (maxYSection > ChunkSection.SECTION_SIZE_Y) maxYSection = ChunkSection.SECTION_SIZE_Y;
 
-            startIndex = sections[sectionY].getChunkSectionData(data, minX, minYSection, minZ, maxX, maxYSection, maxZ, startIndex);
+            startIndex = this.sections[sectionY].getChunkSectionData(data, minX, minYSection, minZ, maxX, maxYSection, maxZ, startIndex);
         }
 
         // Write temperature array
         for (int x = minX; x < maxX; x++) {
             for (int z = minZ; z < maxZ; z++) {
-                data[startIndex++] = (byte) (temperature[x * CHUNK_SIZE_Z + z] * 255D);
+                data[startIndex++] = (byte) (this.temperature[x * CHUNK_SIZE_Z + z] * 255D);
             }
         }
 
         // Write humidity array
         for (int x = minX; x < maxX; x++) {
             for (int z = minZ; z < maxZ; z++) {
-                data[startIndex++] = (byte) (humidity[x * CHUNK_SIZE_Z + z] * 255D);
+                data[startIndex++] = (byte) (this.humidity[x * CHUNK_SIZE_Z + z] * 255D);
             }
         }
 
         // Write variety array
         for (int x = minX; x < maxX; x++) {
             for (int z = minZ; z < maxZ; z++) {
-                data[startIndex++] = (byte) (variety[x * CHUNK_SIZE_Z + z] * 255D);
+                data[startIndex++] = (byte) (this.variety[x * CHUNK_SIZE_Z + z] * 255D);
             }
         }
 
         return startIndex;
     }
 
-    public @NotNull Random getChunkRandom(long xor)
-    {
-        return new Random(world.getRandomSeed() + (this.pos.x * this.pos.x * 0x4c1906L) + (this.pos.x * 0x5ac0dbL) + (this.pos.z * this.pos.z * 0x4307a7L) + (this.pos.z * 0x5f24fL) ^ xor);
+    public @NotNull Random getChunkRandom(long xor) {
+        return new Random(this.world.getRandomSeed() + (this.pos.x * this.pos.x * 0x4c1906L) + (this.pos.x * 0x5ac0dbL) + (this.pos.z * this.pos.z * 0x4307a7L) + (this.pos.z * 0x5f24fL) ^ xor);
     }
 
-    public boolean isChunkEmpty()
-    {
+    public boolean isChunkEmpty() {
         return false;
     }
 
-    public void fixMissingBlocks()
-    {
-        for (ChunkSection section : sections) {
+    public void fixMissingBlocks() {
+        for (ChunkSection section : this.sections) {
             if (section != null && section.blocks != null) {
                 MissingBlockFixer.fixMissingBlocks(section.blocks);
             }
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
index cdf186f65..e2c46382c 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
@@ -4,19 +4,20 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.pos.ChunkPos;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.season.SeasonManager;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class ChunkCache
-    implements WorldSource
-{
+    implements WorldSource {
     private final @NotNull ChunkPos origin;
     private final @NotNull Chunk @NotNull [] @NotNull [] chunkArray;
     private final @NotNull World world;
@@ -26,9 +27,9 @@ public class ChunkCache
 
     public ChunkCache(final @NotNull World world, final @NotNull TilePos min, final @NotNull TilePos max, boolean priority) {
         this.world = world;
-        this.origin = min.toChunkPos();
+        this.origin = new ChunkPos(min);
 
-        final @NotNull ChunkPos chunkMax = max.toChunkPos();
+        final @NotNull ChunkPos chunkMax = new ChunkPos(max);
         this.widthX = (chunkMax.x - this.origin.x) + 1;
         this.widthZ = (chunkMax.z - this.origin.z) + 1;
         this.chunkArray = new Chunk[this.widthX][this.widthZ];
@@ -59,32 +60,32 @@ public class ChunkCache
     }
 
     @Override
-    public int getBlockId(final @NotNull TilePos tilePos) {
-        if (tilePos.y < 0 || tilePos.y >= this.getHeightBlocks()) {
+    public int getBlockId(final @NotNull TilePosc tilePos) {
+        if (tilePos.y() < 0 || tilePos.y() >= this.getHeightBlocks()) {
             return 0;
         }
 
-        final @NotNull ChunkPos cachePos = tilePos.toChunkPos().sub(this.origin);
+        final @NotNull ChunkPos cachePos = new ChunkPos(tilePos).sub(this.origin.x, this.origin.z, new ChunkPos());
         if (cachePos.x < 0 || cachePos.x >= this.chunkArray.length || cachePos.z < 0 || cachePos.z >= this.chunkArray[cachePos.x].length) {
             return 0;
         }
 
         final @NotNull Chunk chunk = this.chunkArray[cachePos.x][cachePos.z];
-        return chunk.getBlockID(tilePos.x & (Chunk.CHUNK_SIZE_X - 1), tilePos.y, tilePos.z & (Chunk.CHUNK_SIZE_Z - 1));
+        return chunk.getBlockID(tilePos.x() & (Chunk.CHUNK_SIZE_X - 1), tilePos.y(), tilePos.z() & (Chunk.CHUNK_SIZE_Z - 1));
     }
 
     @Override
-    public @Nullable Block<?> getBlock(final @NotNull TilePos tilePos) {
+    public @Nullable Block<?> getBlock(final @NotNull TilePosc tilePos) {
         return Blocks.getBlock(this.getBlockId(tilePos));
     }
 
     @Override
-    public @Nullable TileEntity getTileEntity(final @NotNull TilePos tilePos) {
-        final @NotNull ChunkPos cachePos = tilePos.toChunkPos().sub(this.origin);
-        return this.chunkArray[cachePos.x][cachePos.z].getTileEntity(tilePos.x & (Chunk.CHUNK_SIZE_X - 1), tilePos.y, tilePos.z & (Chunk.CHUNK_SIZE_Z - 1));
+    public @Nullable TileEntity getTileEntity(final @NotNull TilePosc tilePos) {
+        final @NotNull ChunkPos cachePos = new ChunkPos(tilePos).sub(this.origin.x, this.origin.z, new ChunkPos());
+        return this.chunkArray[cachePos.x][cachePos.z].getTileEntity(tilePos.x() & (Chunk.CHUNK_SIZE_X - 1), tilePos.y(), tilePos.z() & (Chunk.CHUNK_SIZE_Z - 1));
     }
 
-    public boolean getBlockLitInteriorSurface(final @NotNull TilePos tilePos) {
+    public boolean getBlockLitInteriorSurface(final @NotNull TilePosc tilePos) {
         if (!tilePos.inBounds(this)) {
             return true;
         } else {
@@ -98,30 +99,31 @@ public class ChunkCache
     }
 
     @Override
-    public float getBrightness(final @NotNull TilePos tilePos, final int lightEmission) {
+    public float getBrightness(final @NotNull TilePosc tilePos, final int lightEmission) {
         final int lightValue = this.getBlockLightValue(tilePos);
         return this.world.getWorldType().getBrightnessRamp()[Math.max(lightValue, lightEmission)];
     }
 
     @Override
-    public int getLightmapCoord(final @NotNull TilePos tilePos, final int lightEmission) {
+    public int getLightmapCoord(final @NotNull TilePosc tilePos, final int lightEmission) {
         int skyLight = this.world.getSavedLightValue(LightLayer.Sky, tilePos);
         int blockLight = Math.max(this.world.getSavedLightValue(LightLayer.Block, tilePos), lightEmission);
 
+        TilePos queryPos = new TilePos();
         if (this.getBlockLitInteriorSurface(tilePos)) {
-            skyLight = Math.max(skyLight, this.world.getSavedLightValue(LightLayer.Sky, tilePos.up()));
-            skyLight = Math.max(skyLight, this.world.getSavedLightValue(LightLayer.Sky, tilePos.down()));
-            skyLight = Math.max(skyLight, this.world.getSavedLightValue(LightLayer.Sky, tilePos.east()));
-            skyLight = Math.max(skyLight, this.world.getSavedLightValue(LightLayer.Sky, tilePos.west()));
-            skyLight = Math.max(skyLight, this.world.getSavedLightValue(LightLayer.Sky, tilePos.south()));
-            skyLight = Math.max(skyLight, this.world.getSavedLightValue(LightLayer.Sky, tilePos.north()));
-
-            blockLight = Math.max(blockLight, this.world.getSavedLightValue(LightLayer.Block, tilePos.up()));
-            blockLight = Math.max(blockLight, this.world.getSavedLightValue(LightLayer.Block, tilePos.down()));
-            blockLight = Math.max(blockLight, this.world.getSavedLightValue(LightLayer.Block, tilePos.east()));
-            blockLight = Math.max(blockLight, this.world.getSavedLightValue(LightLayer.Block, tilePos.west()));
-            blockLight = Math.max(blockLight, this.world.getSavedLightValue(LightLayer.Block, tilePos.south()));
-            blockLight = Math.max(blockLight, this.world.getSavedLightValue(LightLayer.Block, tilePos.north()));
+            skyLight = Math.max(skyLight, this.world.getSavedLightValue(LightLayer.Sky, tilePos.up(queryPos)));
+            skyLight = Math.max(skyLight, this.world.getSavedLightValue(LightLayer.Sky, tilePos.down(queryPos)));
+            skyLight = Math.max(skyLight, this.world.getSavedLightValue(LightLayer.Sky, tilePos.east(queryPos)));
+            skyLight = Math.max(skyLight, this.world.getSavedLightValue(LightLayer.Sky, tilePos.west(queryPos)));
+            skyLight = Math.max(skyLight, this.world.getSavedLightValue(LightLayer.Sky, tilePos.south(queryPos)));
+            skyLight = Math.max(skyLight, this.world.getSavedLightValue(LightLayer.Sky, tilePos.north(queryPos)));
+
+            blockLight = Math.max(blockLight, this.world.getSavedLightValue(LightLayer.Block, tilePos.up(queryPos)));
+            blockLight = Math.max(blockLight, this.world.getSavedLightValue(LightLayer.Block, tilePos.down(queryPos)));
+            blockLight = Math.max(blockLight, this.world.getSavedLightValue(LightLayer.Block, tilePos.east(queryPos)));
+            blockLight = Math.max(blockLight, this.world.getSavedLightValue(LightLayer.Block, tilePos.west(queryPos)));
+            blockLight = Math.max(blockLight, this.world.getSavedLightValue(LightLayer.Block, tilePos.south(queryPos)));
+            blockLight = Math.max(blockLight, this.world.getSavedLightValue(LightLayer.Block, tilePos.north(queryPos)));
         }
 
         return this.getLightmapCoord(skyLight, blockLight);
@@ -133,11 +135,11 @@ public class ChunkCache
     }
 
     @Override
-    public float getLightBrightness(final @NotNull TilePos tilePos) {
+    public float getLightBrightness(final @NotNull TilePosc tilePos) {
         return this.world.worldType.getBrightnessRamp()[this.getBlockLightValue(tilePos)];
     }
 
-    public int getBlockLightValue(final @NotNull TilePos tilePos) {
+    public int getBlockLightValue(final @NotNull TilePosc tilePos) {
         return this.getBlockLightValue_do(tilePos, true);
     }
 
@@ -147,83 +149,83 @@ public class ChunkCache
     }
 
     @Deprecated
-    private int getBlockLightValue_do(final @NotNull TilePos tilePos, final boolean first) {
-        if (tilePos.x < World.MIN_BLOCK_X || tilePos.z < World.MIN_BLOCK_Z || tilePos.x >= World.MAX_BLOCK_X || tilePos.z > World.MAX_BLOCK_Z) {
+    private int getBlockLightValue_do(final @NotNull TilePosc tilePos, final boolean first) {
+        if (tilePos.x() < World.MIN_BLOCK_X || tilePos.z() < World.MIN_BLOCK_Z || tilePos.x() >= World.MAX_BLOCK_X || tilePos.z() > World.MAX_BLOCK_Z) {
             return 15;
         }
 
-        if(first) {
-            if (this.getBlockLitInteriorSurface(tilePos))
-            {
-                final int lightUp = this.getBlockLightValue_do(tilePos.up(), false);
-                final int lightEast = this.getBlockLightValue_do(tilePos.east(), false);
-                final int lightWest = this.getBlockLightValue_do(tilePos.west(), false);
-                final int lightSouth = this.getBlockLightValue_do(tilePos.south(), false);
-                final int lightNorth = this.getBlockLightValue_do(tilePos.north(), false);
+        if (first) {
+            TilePos queryPos = new TilePos();
+            if (this.getBlockLitInteriorSurface(tilePos)) {
+                final int lightUp = this.getBlockLightValue_do(tilePos.up(queryPos), false);
+                final int lightEast = this.getBlockLightValue_do(tilePos.east(queryPos), false);
+                final int lightWest = this.getBlockLightValue_do(tilePos.west(queryPos), false);
+                final int lightSouth = this.getBlockLightValue_do(tilePos.south(queryPos), false);
+                final int lightNorth = this.getBlockLightValue_do(tilePos.north(queryPos), false);
                 return Math.max(lightUp, Math.max(lightEast, Math.max(lightWest, Math.max(lightSouth, lightNorth))));
             }
         }
 
-        if (tilePos.y < 0) {
+        if (tilePos.y() < 0) {
             return 0;
         }
 
-        if (tilePos.y >= this.getHeightBlocks()) {
+        if (tilePos.y() >= this.getHeightBlocks()) {
             int brightness = 15 - this.world.skyDarken;
-            if(brightness < 0) {
+            if (brightness < 0) {
                 brightness = 0;
             }
             return brightness;
         } else {
-            final @NotNull ChunkPos cachePos = tilePos.toChunkPos().sub(this.origin);
-            return this.chunkArray[cachePos.x][cachePos.z].getRawBrightness(tilePos.x & (Chunk.CHUNK_SIZE_X - 1), tilePos.y, tilePos.z & (Chunk.CHUNK_SIZE_Z - 1), this.world.skyDarken);
+            final @NotNull ChunkPos cachePos = new ChunkPos(tilePos).sub(this.origin.x, this.origin.z, new ChunkPos());
+            return this.chunkArray[cachePos.x][cachePos.z].getRawBrightness(tilePos.x() & (Chunk.CHUNK_SIZE_X - 1), tilePos.y(), tilePos.z() & (Chunk.CHUNK_SIZE_Z - 1), this.world.skyDarken);
         }
     }
 
     @Override
-    public int getBlockData(final @NotNull TilePos tilePos) {
-        if (tilePos.y < 0 || tilePos.y >= this.getHeightBlocks()) {
+    public int getBlockData(final @NotNull TilePosc tilePos) {
+        if (tilePos.y() < 0 || tilePos.y() >= this.getHeightBlocks()) {
             return 0;
         } else {
-            final @NotNull ChunkPos cachePos = tilePos.toChunkPos().sub(this.origin);
-            return this.chunkArray[cachePos.x][cachePos.z].getBlockMetadata(tilePos.x & (Chunk.CHUNK_SIZE_X - 1), tilePos.y, tilePos.z & (Chunk.CHUNK_SIZE_Z - 1));
+            final @NotNull ChunkPos cachePos = new ChunkPos(tilePos).sub(this.origin.x, this.origin.z, new ChunkPos());
+            return this.chunkArray[cachePos.x][cachePos.z].getBlockMetadata(tilePos.x() & (Chunk.CHUNK_SIZE_X - 1), tilePos.y(), tilePos.z() & (Chunk.CHUNK_SIZE_Z - 1));
         }
     }
 
     @Override
-    public @NotNull Material getBlockMaterial(final @NotNull TilePos tilePos) {
+    public @NotNull Material getBlockMaterial(final @NotNull TilePosc tilePos) {
         final @Nullable Block<?> block = this.getBlock(tilePos);
         if (block == null) {
-            return Material.air;
+            return Materials.AIR;
         } else {
             return block.getMaterial();
         }
     }
 
     @Override
-    public boolean isBlockOpaqueCube(final @NotNull TilePos tilePos) {
+    public boolean isBlockOpaqueCube(final @NotNull TilePosc tilePos) {
         final @Nullable Block<?> block = this.getBlock(tilePos);
         return block != null && block.isSolidRender();
     }
 
     @Override
-    public boolean isBlockNormalCube(final @NotNull TilePos tilePos) {
+    public boolean isBlockNormalCube(final @NotNull TilePosc tilePos) {
         final @Nullable Block<?> block = this.getBlock(tilePos);
-        return block != null && block.getMaterial().isSolidBlocking() && block.renderAsNormalBlockOnCondition(this, tilePos.x, tilePos.y, tilePos.z);
+        return block != null && block.getMaterial().isSolidBlocking() && block.renderAsNormalBlockOnCondition(this, tilePos);
     }
 
     @Override
-    public double getBlockTemperature(final @NotNull TilePos tilePos) {
+    public double getBlockTemperature(final @NotNull TilePosc tilePos) {
         return this.world.getBlockTemperature(tilePos);
     }
 
     @Override
-    public double getBlockHumidity(final @NotNull TilePos tilePos) {
+    public double getBlockHumidity(final @NotNull TilePosc tilePos) {
         return this.world.getBlockHumidity(tilePos);
     }
 
     @Override
-    public double getBlockVariety(final @NotNull TilePos tilePos) {
+    public double getBlockVariety(final @NotNull TilePosc tilePos) {
         return this.world.getBlockVariety(tilePos);
     }
 
@@ -233,12 +235,12 @@ public class ChunkCache
     }
 
     @Override
-    public @NotNull Biome getBlockBiome(final @NotNull TilePos tilePos) {
+    public @NotNull Biome getBlockBiome(final @NotNull TilePosc tilePos) {
         return this.world.getBlockBiome(tilePos);
     }
 
     @Override
-    public int getSavedLightValue(final @NotNull LightLayer lightLayer, final @NotNull TilePos tilePos) {
+    public int getSavedLightValue(final @NotNull LightLayer lightLayer, final @NotNull TilePosc tilePos) {
         return this.world.getSavedLightValue(lightLayer, tilePos);
     }
 
